---
title: URL.createObjectURL()
slug: Web/API/URL/createObjectURL
tags:
  - API
  - Blob
  - DOM
  - File
  - Method
  - Object URL
  - URL
  - URL API
  - createObjectURL
---
<div>{{APIRef("URL API")}}</div>

<p><span class="seoSummary">The <strong><code>URL.createObjectURL()</code></strong> static method creates a {{domxref("DOMString")}} containing a URL representing the object given in the parameter.</span> The URL lifetime is tied to the {{domxref("document")}} in the window on which it was created. The new object URL represents the specified {{domxref("File")}} object or {{domxref("Blob")}} object.</p>

<p>To release an object URL, call {{domxref("URL.revokeObjectURL", "revokeObjectURL()")}}.</p>

<p>{{AvailableInWorkers}}</p>

<div class="note">
<p><strong>Note:</strong> This feature is <em>not</em> available in <a href="/en-US/docs/Web/API/Service_Worker_API">Service Workers</a> due to its potential to create memory leaks.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>objectURL</em> = URL.createObjectURL(<em>object</em>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>object</code></dt>
 <dd>A {{domxref("File")}}, {{domxref("Blob")}}, or {{domxref("MediaSource")}} object to create an object URL for.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("DOMString")}} containing an object URL that can be used to reference the contents of the specified source <code>object</code>.</p>

<ul>
</ul>

<h2 id="Examples">Examples</h2>

<p>See <a href="/en-US/docs/Web/API/File/Using_files_from_web_applications#Example_Using_object_URLs_to_display_images">Using object URLs to display images</a>.</p>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Memory_management">Memory management</h3>

<p>Each time you call <code>createObjectURL()</code>, a new object URL is created, even if you've already created one for the same object. Each of these must be released by calling {{domxref("URL.revokeObjectURL()")}} when you no longer need them.</p>

<p>Browsers will release object URLs automatically when the document is unloaded; however, for optimal performance and memory usage, if there are safe times when you can explicitly unload them, you should do so.</p>

<h3 id="Using_object_URLs_for_media_streams">Using object URLs for media streams</h3>

<p>In older versions of the Media Source specification, attaching a stream to a {{HTMLElement("video")}} element required creating an object URL for the {{domxref("MediaStream")}}. This is no longer necessary, and browsers are removing support for doing this.</p>

<div class="warning">
<p><strong>Important:</strong> If you still have code that relies on {{domxref("URL.createObjectURL", "createObjectURL()")}} to attach streams to media elements, you need to update your code to set {{domxref("HTMLMediaElement.srcObject", "srcObject")}} to the <code>MediaStream</code> directly.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File API', '#dfn-createObjectURL', 'createObjectURL()')}}</td>
   <td>{{Spec2('File API')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('Media Source Extensions', '#dom-url-createobjecturl', 'URL')}}</td>
   <td>{{Spec2('Media Source Extensions')}}</td>
   <td>
    <p>MediaSource extension.</p>

    <p>Older versions of this specification used <code>createObjectURL()</code> for {{domxref("MediaStream")}} objects; this is no longer supported.</p>
   </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.URL.createObjectURL")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File/Using_files_from_web_applications" title="Using files from web applications">Using files from web applications</a></li>
 <li><a href="/en-US/docs/Web/API/File/Using_files_from_web_applications#Example_Using_object_URLs_to_display_images">Using object URLs to display images</a></li>
 <li>{{domxref("URL.revokeObjectURL()")}}</li>
 <li>{{domxref("HTMLMediaElement.srcObject")}}</li>
 <li>{{domxref("FileReader.readAsDataURL()")}}</li>
</ul>
